# TelegramNewsBot

Берет новости из базы данных сайта кафедры и отправляет через бота новости в канал в Телеграме

## Установка

Использование данного скрипта планируется на ОС Linux с использованием таймера для периодичного запуска.

1. Установка необходимого ПО:
```bash
apt install git mc curl python3-pip python3-venv
```
2. Клонировать проект в необходимою папку (например в /opt):
```bash
git clone https://git.athene.tech/sam/TelegramNewsBot.git
```
3. Создать виртуальное окружение Python:
```bash
python3 -m venv virt_env
```
4. Установить необходимые драйвера для работы ODBC с https://docs.microsoft.com/ru-ru/sql/connect/odbc/linux-mac/installing-the-microsoft-odbc-driver-for-sql-server:
5. При использовании старой версии MS SQL Server необходимо отключить использование новых стандартов шифрования:
    1. Открыть файл:
    ```bash
    mcedit /etc/ssl/openssl.cnf
    ```
    2. Вставить в начало файла:
    ```conf
    openssl_conf = default_conf
    ```
    3. Вставить в конец файла:
    ```conf
    [default_conf]
    ssl_conf = ssl_sect

    [ssl_sect]
    system_default = system_default_sect

    [system_default_sect]
    MinProtocol = TLSv1
    CipherString = DEFAULT@SECLEVEL=1
    ```
6. Установить необходимые зависимости в виртуальное окружение (выполняется из расположения проекта):
```bash
source virt_env/bin/activate
pip install -r requirements.txt
```
7. Настроить таймер для выполнения скрипта:
```bash
cp /systemd/* /etc/systemd/system/
systemctl daemon-reload
systemctl enable telegram.bot.news.timer
systemctl start telegram.bot.news.timer
```